/* Scripts

   Copyright (C) 2003 Free Software Foundation
   Autors: 2003 Mateusz Golicz <mteg@jaszczur.org>

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

#include <ctype.h>
#include <stdio.h>
#include "edit.h"
#include "editcmddef.h"
#include "config.h"

struct pipeoper
{
	char * command_name;
	int needs_block;
};

static struct pipeoper ** pipeopers = NULL;
int n_pipeopers = 0;

void edit_block_process_cmd (WEdit * edit, const char *shell_cmd, int block);

void handle_pipeoper(WEdit * we, int pid)
{
	unsigned char * f;
	FILE *fh;
	
	if(pid < 0 || pid >= n_pipeopers) return;
	
	if(*(pipeopers[pid]->command_name) != '/')
	{
		f = catstrs(conf_dir, "/scripts/", pipeopers[pid]->command_name, 0);
		if((fh = fopen(f, "r")))
			fclose(fh);
		else
			f = catstrs(LIBDIR "/scripts/", pipeopers[pid]->command_name, 0);
	}
	else
		f = pipeopers[pid]->command_name;
	
	if((fh = fopen(f, "r")))
		fclose(fh);
	else
		return;

	edit_block_process_cmd(we, f, pipeopers[pid]->needs_block);
}

int register_pipeoper(char * name, int needs_block)
{
	pipeopers = (struct pipeoper**) realloc(pipeopers, sizeof(struct pipeoper*) * (n_pipeopers + 1));
	pipeopers[n_pipeopers] = (struct pipeoper*) malloc(sizeof(struct pipeoper));
	pipeopers[n_pipeopers]->command_name = strdup(name);
	pipeopers[n_pipeopers]->needs_block = needs_block;
	return(CK_Pipe_Block(n_pipeopers++));
}
